# vim: set fileencoding=utf-8 :

def get(ccy, default=None):
    return _dump.get(ccy, default)

if __name__ == "__main__":
    """Download and dump ISO4217 current currency list."""
    import urllib.request
    import xml.etree.ElementTree as ET
    url = "https://www.currency-iso.org/dam/downloads/lists/list_one.xml"

    tree = ET.parse(urllib.request.urlopen(url))
    items = {}
    for e in tree.findall("./CcyTbl/CcyNtry"):
        ccy = e.findtext("./Ccy")
        if ccy is not None:
            name = "{0} {1}".format(
                    e.findtext("./CtryNm"),
                    e.findtext("./CcyNm")
                    ).strip()
            exp = e.findtext("./CcyMnrUnts", "N.A.")
            items[ccy] = {
                    "name": name,
                    "fraction": None if exp == "N.A." else "1" + "0" * int(exp),
                    }
    print(items)

_dump = \
{'AFN': {'name': 'AFGHANISTAN Afghani', 'fraction': '100'}, 'EUR': {'name': 'SPAIN Euro', 'fraction': '100'}, 'ALL': {'name': 'ALBANIA Lek', 'fraction': '100'}, 'DZD': {'name': 'ALGERIA Algerian Dinar', 'fraction': '100'}, 'USD': {'name': 'VIRGIN ISLANDS (U.S.) US Dollar', 'fraction': '100'}, 'AOA': {'name': 'ANGOLA Kwanza', 'fraction': '100'}, 'XCD': {'name': 'SAINT VINCENT AND THE GRENADINES East Caribbean Dollar', 'fraction': '100'}, 'ARS': {'name': 'ARGENTINA Argentine Peso', 'fraction': '100'}, 'AMD': {'name': 'ARMENIA Armenian Dram', 'fraction': '100'}, 'AWG': {'name': 'ARUBA Aruban Florin', 'fraction': '100'}, 'AUD': {'name': 'TUVALU Australian Dollar', 'fraction': '100'}, 'AZN': {'name': 'AZERBAIJAN Azerbaijan Manat', 'fraction': '100'}, 'BSD': {'name': 'BAHAMAS (THE) Bahamian Dollar', 'fraction': '100'}, 'BHD': {'name': 'BAHRAIN Bahraini Dinar', 'fraction': '1000'}, 'BDT': {'name': 'BANGLADESH Taka', 'fraction': '100'}, 'BBD': {'name': 'BARBADOS Barbados Dollar', 'fraction': '100'}, 'BYN': {'name': 'BELARUS Belarusian Ruble', 'fraction': '100'}, 'BZD': {'name': 'BELIZE Belize Dollar', 'fraction': '100'}, 'XOF': {'name': 'TOGO CFA Franc BCEAO', 'fraction': '1'}, 'BMD': {'name': 'BERMUDA Bermudian Dollar', 'fraction': '100'}, 'INR': {'name': 'INDIA Indian Rupee', 'fraction': '100'}, 'BTN': {'name': 'BHUTAN Ngultrum', 'fraction': '100'}, 'BOB': {'name': 'BOLIVIA (PLURINATIONAL STATE OF) Boliviano', 'fraction': '100'}, 'BOV': {'name': 'BOLIVIA (PLURINATIONAL STATE OF) Mvdol', 'fraction': '100'}, 'BAM': {'name': 'BOSNIA AND HERZEGOVINA Convertible Mark', 'fraction': '100'}, 'BWP': {'name': 'BOTSWANA Pula', 'fraction': '100'}, 'NOK': {'name': 'SVALBARD AND JAN MAYEN Norwegian Krone', 'fraction': '100'}, 'BRL': {'name': 'BRAZIL Brazilian Real', 'fraction': '100'}, 'BND': {'name': 'BRUNEI DARUSSALAM Brunei Dollar', 'fraction': '100'}, 'BGN': {'name': 'BULGARIA Bulgarian Lev', 'fraction': '100'}, 'BIF': {'name': 'BURUNDI Burundi Franc', 'fraction': '1'}, 'CVE': {'name': 'CABO VERDE Cabo Verde Escudo', 'fraction': '100'}, 'KHR': {'name': 'CAMBODIA Riel', 'fraction': '100'}, 'XAF': {'name': 'GABON CFA Franc BEAC', 'fraction': '1'}, 'CAD': {'name': 'CANADA Canadian Dollar', 'fraction': '100'}, 'KYD': {'name': 'CAYMAN ISLANDS (THE) Cayman Islands Dollar', 'fraction': '100'}, 'CLP': {'name': 'CHILE Chilean Peso', 'fraction': '1'}, 'CLF': {'name': 'CHILE Unidad de Fomento', 'fraction': '10000'}, 'CNY': {'name': 'CHINA Yuan Renminbi', 'fraction': '100'}, 'COP': {'name': 'COLOMBIA Colombian Peso', 'fraction': '100'}, 'COU': {'name': 'COLOMBIA Unidad de Valor Real', 'fraction': '100'}, 'KMF': {'name': 'COMOROS (THE) Comorian Franc', 'fraction': '1'}, 'CDF': {'name': 'CONGO (THE DEMOCRATIC REPUBLIC OF THE) Congolese Franc', 'fraction': '100'}, 'NZD': {'name': 'TOKELAU New Zealand Dollar', 'fraction': '100'}, 'CRC': {'name': 'COSTA RICA Costa Rican Colon', 'fraction': '100'}, 'HRK': {'name': 'CROATIA Kuna', 'fraction': '100'}, 'CUP': {'name': 'CUBA Cuban Peso', 'fraction': '100'}, 'CUC': {'name': 'CUBA Peso Convertible', 'fraction': '100'}, 'ANG': {'name': 'SINT MAARTEN (DUTCH PART) Netherlands Antillean Guilder', 'fraction': '100'}, 'CZK': {'name': 'CZECHIA Czech Koruna', 'fraction': '100'}, 'DKK': {'name': 'GREENLAND Danish Krone', 'fraction': '100'}, 'DJF': {'name': 'DJIBOUTI Djibouti Franc', 'fraction': '1'}, 'DOP': {'name': 'DOMINICAN REPUBLIC (THE) Dominican Peso', 'fraction': '100'}, 'EGP': {'name': 'EGYPT Egyptian Pound', 'fraction': '100'}, 'SVC': {'name': 'EL SALVADOR El Salvador Colon', 'fraction': '100'}, 'ERN': {'name': 'ERITREA Nakfa', 'fraction': '100'}, 'ETB': {'name': 'ETHIOPIA Ethiopian Birr', 'fraction': '100'}, 'FKP': {'name': 'FALKLAND ISLANDS (THE) [MALVINAS] Falkland Islands Pound', 'fraction': '100'}, 'FJD': {'name': 'FIJI Fiji Dollar', 'fraction': '100'}, 'XPF': {'name': 'WALLIS AND FUTUNA CFP Franc', 'fraction': '1'}, 'GMD': {'name': 'GAMBIA (THE) Dalasi', 'fraction': '100'}, 'GEL': {'name': 'GEORGIA Lari', 'fraction': '100'}, 'GHS': {'name': 'GHANA Ghana Cedi', 'fraction': '100'}, 'GIP': {'name': 'GIBRALTAR Gibraltar Pound', 'fraction': '100'}, 'GTQ': {'name': 'GUATEMALA Quetzal', 'fraction': '100'}, 'GBP': {'name': 'UNITED KINGDOM OF GREAT BRITAIN AND NORTHERN IRELAND (THE) Pound Sterling', 'fraction': '100'}, 'GNF': {'name': 'GUINEA Guinean Franc', 'fraction': '1'}, 'GYD': {'name': 'GUYANA Guyana Dollar', 'fraction': '100'}, 'HTG': {'name': 'HAITI Gourde', 'fraction': '100'}, 'HNL': {'name': 'HONDURAS Lempira', 'fraction': '100'}, 'HKD': {'name': 'HONG KONG Hong Kong Dollar', 'fraction': '100'}, 'HUF': {'name': 'HUNGARY Forint', 'fraction': '100'}, 'ISK': {'name': 'ICELAND Iceland Krona', 'fraction': '1'}, 'IDR': {'name': 'INDONESIA Rupiah', 'fraction': '100'}, 'XDR': {'name': 'INTERNATIONAL MONETARY FUND (IMF)\xa0 SDR (Special Drawing Right)', 'fraction': None}, 'IRR': {'name': 'IRAN (ISLAMIC REPUBLIC OF) Iranian Rial', 'fraction': '100'}, 'IQD': {'name': 'IRAQ Iraqi Dinar', 'fraction': '1000'}, 'ILS': {'name': 'ISRAEL New Israeli Sheqel', 'fraction': '100'}, 'JMD': {'name': 'JAMAICA Jamaican Dollar', 'fraction': '100'}, 'JPY': {'name': 'JAPAN Yen', 'fraction': '1'}, 'JOD': {'name': 'JORDAN Jordanian Dinar', 'fraction': '1000'}, 'KZT': {'name': 'KAZAKHSTAN Tenge', 'fraction': '100'}, 'KES': {'name': 'KENYA Kenyan Shilling', 'fraction': '100'}, 'KPW': {'name': 'KOREA (THE DEMOCRATIC PEOPLE’S REPUBLIC OF) North Korean Won', 'fraction': '100'}, 'KRW': {'name': 'KOREA (THE REPUBLIC OF) Won', 'fraction': '1'}, 'KWD': {'name': 'KUWAIT Kuwaiti Dinar', 'fraction': '1000'}, 'KGS': {'name': 'KYRGYZSTAN Som', 'fraction': '100'}, 'LAK': {'name': 'LAO PEOPLE’S DEMOCRATIC REPUBLIC (THE) Lao Kip', 'fraction': '100'}, 'LBP': {'name': 'LEBANON Lebanese Pound', 'fraction': '100'}, 'LSL': {'name': 'LESOTHO Loti', 'fraction': '100'}, 'ZAR': {'name': 'SOUTH AFRICA Rand', 'fraction': '100'}, 'LRD': {'name': 'LIBERIA Liberian Dollar', 'fraction': '100'}, 'LYD': {'name': 'LIBYA Libyan Dinar', 'fraction': '1000'}, 'CHF': {'name': 'SWITZERLAND Swiss Franc', 'fraction': '100'}, 'MOP': {'name': 'MACAO Pataca', 'fraction': '100'}, 'MKD': {'name': 'MACEDONIA (THE FORMER YUGOSLAV REPUBLIC OF) Denar', 'fraction': '100'}, 'MGA': {'name': 'MADAGASCAR Malagasy Ariary', 'fraction': '100'}, 'MWK': {'name': 'MALAWI Malawi Kwacha', 'fraction': '100'}, 'MYR': {'name': 'MALAYSIA Malaysian Ringgit', 'fraction': '100'}, 'MVR': {'name': 'MALDIVES Rufiyaa', 'fraction': '100'}, 'MRO': {'name': 'MAURITANIA Ouguiya', 'fraction': '100'}, 'MUR': {'name': 'MAURITIUS Mauritius Rupee', 'fraction': '100'}, 'XUA': {'name': 'MEMBER COUNTRIES OF THE AFRICAN DEVELOPMENT BANK GROUP ADB Unit of Account', 'fraction': None}, 'MXN': {'name': 'MEXICO Mexican Peso', 'fraction': '100'}, 'MXV': {'name': 'MEXICO Mexican Unidad de Inversion (UDI)', 'fraction': '100'}, 'MDL': {'name': 'MOLDOVA (THE REPUBLIC OF) Moldovan Leu', 'fraction': '100'}, 'MNT': {'name': 'MONGOLIA Tugrik', 'fraction': '100'}, 'MAD': {'name': 'WESTERN SAHARA Moroccan Dirham', 'fraction': '100'}, 'MZN': {'name': 'MOZAMBIQUE Mozambique Metical', 'fraction': '100'}, 'MMK': {'name': 'MYANMAR Kyat', 'fraction': '100'}, 'NAD': {'name': 'NAMIBIA Namibia Dollar', 'fraction': '100'}, 'NPR': {'name': 'NEPAL Nepalese Rupee', 'fraction': '100'}, 'NIO': {'name': 'NICARAGUA Cordoba Oro', 'fraction': '100'}, 'NGN': {'name': 'NIGERIA Naira', 'fraction': '100'}, 'OMR': {'name': 'OMAN Rial Omani', 'fraction': '1000'}, 'PKR': {'name': 'PAKISTAN Pakistan Rupee', 'fraction': '100'}, 'PAB': {'name': 'PANAMA Balboa', 'fraction': '100'}, 'PGK': {'name': 'PAPUA NEW GUINEA Kina', 'fraction': '100'}, 'PYG': {'name': 'PARAGUAY Guarani', 'fraction': '1'}, 'PEN': {'name': 'PERU Sol', 'fraction': '100'}, 'PHP': {'name': 'PHILIPPINES (THE) Philippine Piso', 'fraction': '100'}, 'PLN': {'name': 'POLAND Zloty', 'fraction': '100'}, 'QAR': {'name': 'QATAR Qatari Rial', 'fraction': '100'}, 'RON': {'name': 'ROMANIA Romanian Leu', 'fraction': '100'}, 'RUB': {'name': 'RUSSIAN FEDERATION (THE) Russian Ruble', 'fraction': '100'}, 'RWF': {'name': 'RWANDA Rwanda Franc', 'fraction': '1'}, 'SHP': {'name': 'SAINT HELENA, ASCENSION AND TRISTAN DA CUNHA Saint Helena Pound', 'fraction': '100'}, 'WST': {'name': 'SAMOA Tala', 'fraction': '100'}, 'STD': {'name': 'SAO TOME AND PRINCIPE Dobra', 'fraction': '100'}, 'SAR': {'name': 'SAUDI ARABIA Saudi Riyal', 'fraction': '100'}, 'RSD': {'name': 'SERBIA Serbian Dinar', 'fraction': '100'}, 'SCR': {'name': 'SEYCHELLES Seychelles Rupee', 'fraction': '100'}, 'SLL': {'name': 'SIERRA LEONE Leone', 'fraction': '100'}, 'SGD': {'name': 'SINGAPORE Singapore Dollar', 'fraction': '100'}, 'XSU': {'name': 'SISTEMA UNITARIO DE COMPENSACION REGIONAL DE PAGOS "SUCRE" Sucre', 'fraction': None}, 'SBD': {'name': 'SOLOMON ISLANDS Solomon Islands Dollar', 'fraction': '100'}, 'SOS': {'name': 'SOMALIA Somali Shilling', 'fraction': '100'}, 'SSP': {'name': 'SOUTH SUDAN South Sudanese Pound', 'fraction': '100'}, 'LKR': {'name': 'SRI LANKA Sri Lanka Rupee', 'fraction': '100'}, 'SDG': {'name': 'SUDAN (THE) Sudanese Pound', 'fraction': '100'}, 'SRD': {'name': 'SURINAME Surinam Dollar', 'fraction': '100'}, 'SZL': {'name': 'SWAZILAND Lilangeni', 'fraction': '100'}, 'SEK': {'name': 'SWEDEN Swedish Krona', 'fraction': '100'}, 'CHE': {'name': 'SWITZERLAND WIR Euro', 'fraction': '100'}, 'CHW': {'name': 'SWITZERLAND WIR Franc', 'fraction': '100'}, 'SYP': {'name': 'SYRIAN ARAB REPUBLIC Syrian Pound', 'fraction': '100'}, 'TWD': {'name': 'TAIWAN (PROVINCE OF CHINA) New Taiwan Dollar', 'fraction': '100'}, 'TJS': {'name': 'TAJIKISTAN Somoni', 'fraction': '100'}, 'TZS': {'name': 'TANZANIA, UNITED REPUBLIC OF Tanzanian Shilling', 'fraction': '100'}, 'THB': {'name': 'THAILAND Baht', 'fraction': '100'}, 'TOP': {'name': 'TONGA Pa’anga', 'fraction': '100'}, 'TTD': {'name': 'TRINIDAD AND TOBAGO Trinidad and Tobago Dollar', 'fraction': '100'}, 'TND': {'name': 'TUNISIA Tunisian Dinar', 'fraction': '1000'}, 'TRY': {'name': 'TURKEY Turkish Lira', 'fraction': '100'}, 'TMT': {'name': 'TURKMENISTAN Turkmenistan New Manat', 'fraction': '100'}, 'UGX': {'name': 'UGANDA Uganda Shilling', 'fraction': '1'}, 'UAH': {'name': 'UKRAINE Hryvnia', 'fraction': '100'}, 'AED': {'name': 'UNITED ARAB EMIRATES (THE) UAE Dirham', 'fraction': '100'}, 'USN': {'name': 'UNITED STATES OF AMERICA (THE) US Dollar (Next day)', 'fraction': '100'}, 'UYU': {'name': 'URUGUAY Peso Uruguayo', 'fraction': '100'}, 'UYI': {'name': 'URUGUAY Uruguay Peso en Unidades Indexadas (URUIURUI)', 'fraction': '1'}, 'UZS': {'name': 'UZBEKISTAN Uzbekistan Sum', 'fraction': '100'}, 'VUV': {'name': 'VANUATU Vatu', 'fraction': '1'}, 'VEF': {'name': 'VENEZUELA (BOLIVARIAN REPUBLIC OF) Bolívar', 'fraction': '100'}, 'VND': {'name': 'VIET NAM Dong', 'fraction': '1'}, 'YER': {'name': 'YEMEN Yemeni Rial', 'fraction': '100'}, 'ZMW': {'name': 'ZAMBIA Zambian Kwacha', 'fraction': '100'}, 'ZWL': {'name': 'ZIMBABWE Zimbabwe Dollar', 'fraction': '100'}, 'XBA': {'name': 'ZZ01_Bond Markets Unit European_EURCO Bond Markets Unit European Composite Unit (EURCO)', 'fraction': None}, 'XBB': {'name': 'ZZ02_Bond Markets Unit European_EMU-6 Bond Markets Unit European Monetary Unit (E.M.U.-6)', 'fraction': None}, 'XBC': {'name': 'ZZ03_Bond Markets Unit European_EUA-9 Bond Markets Unit European Unit of Account 9 (E.U.A.-9)', 'fraction': None}, 'XBD': {'name': 'ZZ04_Bond Markets Unit European_EUA-17 Bond Markets Unit European Unit of Account 17 (E.U.A.-17)', 'fraction': None}, 'XTS': {'name': 'ZZ06_Testing_Code Codes specifically reserved for testing purposes', 'fraction': None}, 'XXX': {'name': 'ZZ07_No_Currency The codes assigned for transactions where no currency is involved', 'fraction': None}, 'XAU': {'name': 'ZZ08_Gold Gold', 'fraction': None}, 'XPD': {'name': 'ZZ09_Palladium Palladium', 'fraction': None}, 'XPT': {'name': 'ZZ10_Platinum Platinum', 'fraction': None}, 'XAG': {'name': 'ZZ11_Silver Silver', 'fraction': None}}
